# PimClient

PIM

This PHP package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.0
- Build package: org.openapitools.codegen.languages.PhpClientCodegen
For more information, please visit [https://greensight.ru/](https://greensight.ru/)

## Requirements

PHP 5.5 and later

## Installation & Usage

### Composer

To install the bindings via [Composer](http://getcomposer.org/), add the following to `composer.json`:

```json
{
  "repositories": [
    {
      "type": "vcs",
      "url": "https://gitlab.com/greensight/ensi/catalog/clients/pim-client-php.git"
    }
  ],
  "require": {
    "greensight/ensi/catalog/clients/pim-client-php": "*@dev"
  }
}
```

Then run `composer install`

### Manual Installation

Download the files and include `autoload.php`:

```php
    require_once('/path/to/PimClient/vendor/autoload.php');
```

## Tests

To run the unit tests:

```bash
composer install
./vendor/bin/phpunit
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');



$apiInstance = new Ensi\PimClient\Api\BrandsApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client()
);
$create_brand_request = new \Ensi\PimClient\Dto\CreateBrandRequest(); // \Ensi\PimClient\Dto\CreateBrandRequest | 

try {
    $result = $apiInstance->createBrand($create_brand_request);
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling BrandsApi->createBrand: ', $e->getMessage(), PHP_EOL;
}

?>
```

## Documentation for API Endpoints

All URIs are relative to *http://localhost/api/v1*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*BrandsApi* | [**createBrand**](docs/Api/BrandsApi.md#createbrand) | **POST** /classifiers/brands | Запрос на создание нового бренда
*BrandsApi* | [**deleteBrand**](docs/Api/BrandsApi.md#deletebrand) | **DELETE** /classifiers/brands/{id} | Запрос на удаление бренда по ID
*BrandsApi* | [**deleteBrandImage**](docs/Api/BrandsApi.md#deletebrandimage) | **POST** /classifiers/brands/{id}:delete-image | Удаление текущей картинки бренда
*BrandsApi* | [**getBrand**](docs/Api/BrandsApi.md#getbrand) | **GET** /classifiers/brands/{id} | Запрос бренда по ID
*BrandsApi* | [**massDeleteBrands**](docs/Api/BrandsApi.md#massdeletebrands) | **POST** /classifiers/brands:mass-delete | Массовое удаление брендов
*BrandsApi* | [**patchBrand**](docs/Api/BrandsApi.md#patchbrand) | **PATCH** /classifiers/brands/{id} | Обновляет отдельные поля бренда
*BrandsApi* | [**replaceBrand**](docs/Api/BrandsApi.md#replacebrand) | **PUT** /classifiers/brands/{id} | Запрос на обновление бренда
*BrandsApi* | [**searchBrands**](docs/Api/BrandsApi.md#searchbrands) | **POST** /classifiers/brands:search | Поиск брендов, удовлетворяющих фильтру
*BrandsApi* | [**uploadBrandImage**](docs/Api/BrandsApi.md#uploadbrandimage) | **POST** /classifiers/brands/{id}:upload-image | Загрузка картинки для бренда
*CategoriesApi* | [**bindCategoryProperties**](docs/Api/CategoriesApi.md#bindcategoryproperties) | **POST** /categories/categories/{id}:bind-properties | Запрос на изменение привязанных к категории атрибутов
*CategoriesApi* | [**createCategory**](docs/Api/CategoriesApi.md#createcategory) | **POST** /categories/categories | Запрос на создание новой категории
*CategoriesApi* | [**deleteCategories**](docs/Api/CategoriesApi.md#deletecategories) | **POST** /categories/categories:mass-delete | Массовое удаление категорий
*CategoriesApi* | [**deleteCategory**](docs/Api/CategoriesApi.md#deletecategory) | **DELETE** /categories/categories/{id} | Запрос на удаление категории
*CategoriesApi* | [**deleteCategoryImage**](docs/Api/CategoriesApi.md#deletecategoryimage) | **POST** /categories/categories/{id}:delete-image | Удаление текущей картинки категории
*CategoriesApi* | [**getCategoriesTree**](docs/Api/CategoriesApi.md#getcategoriestree) | **POST** /categories/categories:tree | Формирование дерева категорий
*CategoriesApi* | [**getCategory**](docs/Api/CategoriesApi.md#getcategory) | **GET** /categories/categories/{id} | Запрос категории по ID
*CategoriesApi* | [**patchCategory**](docs/Api/CategoriesApi.md#patchcategory) | **PATCH** /categories/categories/{id} | Запрос на обновление отдельных полей категории
*CategoriesApi* | [**replaceCategory**](docs/Api/CategoriesApi.md#replacecategory) | **PUT** /categories/categories/{id} | Запрос на обновление категории
*CategoriesApi* | [**searchCategories**](docs/Api/CategoriesApi.md#searchcategories) | **POST** /categories/categories:search | Поиск категорий, удовлетворяющих фильтру
*CategoriesApi* | [**uploadCategoryImage**](docs/Api/CategoriesApi.md#uploadcategoryimage) | **POST** /categories/categories/{id}:upload-image | Загрузка картинки для категории
*EnumsApi* | [**getMetricsCategories**](docs/Api/EnumsApi.md#getmetricscategories) | **GET** /classifiers/enums/metrics-categories | Возвращает информацию о доступных метриках ваалидации товаров
*EnumsApi* | [**getProductTypes**](docs/Api/EnumsApi.md#getproducttypes) | **GET** /classifiers/enums/product-types | Возвращает информацию о доступных типах товаров
*EnumsApi* | [**getPropertyTypes**](docs/Api/EnumsApi.md#getpropertytypes) | **GET** /classifiers/enums/property-types | Возвращает информацию о доступных типах атрибутов
*ProductFieldsApi* | [**getProductField**](docs/Api/ProductFieldsApi.md#getproductfield) | **GET** /classifiers/product-fields/{id} | Получение настроек поля по идентификатору
*ProductFieldsApi* | [**patchProductField**](docs/Api/ProductFieldsApi.md#patchproductfield) | **PATCH** /classifiers/product-fields/{id} | Обновление настроек поля товара
*ProductFieldsApi* | [**searchProductFields**](docs/Api/ProductFieldsApi.md#searchproductfields) | **POST** /classifiers/product-fields:search | Поиск полей товаров, удовлетворяющих условиям отбора
*ProductFlagsApi* | [**getProductFlag**](docs/Api/ProductFlagsApi.md#getproductflag) | **GET** /classifiers/product-flags/{id} | Получение признака по идентификатору
*ProductFlagsApi* | [**replaceProductFlag**](docs/Api/ProductFlagsApi.md#replaceproductflag) | **PUT** /classifiers/product-flags/{id} | Обновление данных признака
*ProductFlagsApi* | [**searchProductFlags**](docs/Api/ProductFlagsApi.md#searchproductflags) | **POST** /classifiers/product-flags:search | Поиск признаков товаров, удовлетворяющих условиям отбора
*ProductStatusesApi* | [**getProductStatus**](docs/Api/ProductStatusesApi.md#getproductstatus) | **GET** /classifiers/product-statuses/{id} | Получение статуса по идентификатору
*ProductStatusesApi* | [**replaceProductStatus**](docs/Api/ProductStatusesApi.md#replaceproductstatus) | **PUT** /classifiers/product-statuses/{id} | Обновление данных статуса
*ProductStatusesApi* | [**searchProductStatuses**](docs/Api/ProductStatusesApi.md#searchproductstatuses) | **POST** /classifiers/product-statuses:search | Поиск статусов товаров, удовлетворяющих условиям отбора
*ProductsApi* | [**createProduct**](docs/Api/ProductsApi.md#createproduct) | **POST** /products/products | Запрос на создание нового товара
*ProductsApi* | [**deleteProduct**](docs/Api/ProductsApi.md#deleteproduct) | **DELETE** /products/products/{id} | Запрос на удаление товара
*ProductsApi* | [**getProduct**](docs/Api/ProductsApi.md#getproduct) | **GET** /products/published/{id} | Запрос на получение опубликованной версии товара
*ProductsApi* | [**getProductDraft**](docs/Api/ProductsApi.md#getproductdraft) | **GET** /products/products/{id} | Запрос на получение черновика товара
*ProductsApi* | [**massDeleteProducts**](docs/Api/ProductsApi.md#massdeleteproducts) | **POST** /products/products:mass-delete | Массовое удаление товаров
*ProductsApi* | [**patchProduct**](docs/Api/ProductsApi.md#patchproduct) | **PATCH** /products/products/{id} | Запрос на обновление отдельных свойств товара
*ProductsApi* | [**patchProductAttributes**](docs/Api/ProductsApi.md#patchproductattributes) | **PATCH** /products/products/{id}/attributes | Обновление только заданных атрибутов товара
*ProductsApi* | [**patchProductImages**](docs/Api/ProductsApi.md#patchproductimages) | **PATCH** /products/products/{id}/images | Обновление только заданных картинок
*ProductsApi* | [**preloadProductImage**](docs/Api/ProductsApi.md#preloadproductimage) | **POST** /products/products:preload-image | Загрузка картинки для товара или атрибута товара
*ProductsApi* | [**replaceProduct**](docs/Api/ProductsApi.md#replaceproduct) | **PUT** /products/products/{id} | Запрос на обновление товара
*ProductsApi* | [**replaceProductAttributes**](docs/Api/ProductsApi.md#replaceproductattributes) | **PUT** /products/products/{id}/attributes | Замещение всех атрибутов товара
*ProductsApi* | [**replaceProductImages**](docs/Api/ProductsApi.md#replaceproductimages) | **PUT** /products/products/{id}/images | Замещение всех картинок товара
*ProductsApi* | [**searchProductDrafts**](docs/Api/ProductsApi.md#searchproductdrafts) | **POST** /products/products:search | Поиск черновиков товаров, удовлетворяющих фильтру
*ProductsApi* | [**searchProducts**](docs/Api/ProductsApi.md#searchproducts) | **POST** /products/published:search | Поиск опубликованных товаров, удовлетворяющих фильтру
*PropertiesApi* | [**createDirectoryValue**](docs/Api/PropertiesApi.md#createdirectoryvalue) | **POST** /categories/properties/{id}:add-directory | Запрос на создание нового значения справочника
*PropertiesApi* | [**createProperty**](docs/Api/PropertiesApi.md#createproperty) | **POST** /categories/properties | Запрос на создание нового свойства
*PropertiesApi* | [**deleteDirectoryValue**](docs/Api/PropertiesApi.md#deletedirectoryvalue) | **DELETE** /categories/properties/directory/{id} | Запрос на удаление значения справочника
*PropertiesApi* | [**deleteProperties**](docs/Api/PropertiesApi.md#deleteproperties) | **POST** /categories/properties:mass-delete | Массовое удаление свойств
*PropertiesApi* | [**deleteProperty**](docs/Api/PropertiesApi.md#deleteproperty) | **DELETE** /categories/properties/{id} | Запрос на удаление свойства
*PropertiesApi* | [**getDirectoryValue**](docs/Api/PropertiesApi.md#getdirectoryvalue) | **GET** /categories/properties/directory/{id} | Возвращает данные значения справочника
*PropertiesApi* | [**getProperty**](docs/Api/PropertiesApi.md#getproperty) | **GET** /categories/properties/{id} | Получение данных свойства
*PropertiesApi* | [**patchDirectoryValue**](docs/Api/PropertiesApi.md#patchdirectoryvalue) | **PATCH** /categories/properties/directory/{id} | Запрос на обновление отдельных атрибутов значения справочника
*PropertiesApi* | [**patchProperty**](docs/Api/PropertiesApi.md#patchproperty) | **PATCH** /categories/properties/{id} | Запрос на обновление отдельных атрибутов свойства
*PropertiesApi* | [**preloadDirectoryValueFile**](docs/Api/PropertiesApi.md#preloaddirectoryvaluefile) | **POST** /categories/properties/directory:preload-file | Загрузка файла для значения справочника
*PropertiesApi* | [**preloadDirectoryValueImage**](docs/Api/PropertiesApi.md#preloaddirectoryvalueimage) | **POST** /categories/properties/directory:preload-image | Загрузка картинки для значения справочника
*PropertiesApi* | [**replaceDirectoryValue**](docs/Api/PropertiesApi.md#replacedirectoryvalue) | **PUT** /categories/properties/directory/{id} | Запрос на обновление значения справочника
*PropertiesApi* | [**replaceProperty**](docs/Api/PropertiesApi.md#replaceproperty) | **PUT** /categories/properties/{id} | Запрос на обновление свойства
*PropertiesApi* | [**searchDirectoryValues**](docs/Api/PropertiesApi.md#searchdirectoryvalues) | **POST** /categories/properties/directory:search | Поиск значений справочников, удовлетворяющих фильтру
*PropertiesApi* | [**searchProperties**](docs/Api/PropertiesApi.md#searchproperties) | **POST** /categories/properties:search | Поиск свойств, удовлетворяющих фильтру
*VariantsApi* | [**createVariantGroup**](docs/Api/VariantsApi.md#createvariantgroup) | **POST** /products/variants | Запрос на создание новой склейки
*VariantsApi* | [**deleteVariantGroup**](docs/Api/VariantsApi.md#deletevariantgroup) | **DELETE** /products/variants/{id} | Запрос на удаление склейки
*VariantsApi* | [**getVariantGroup**](docs/Api/VariantsApi.md#getvariantgroup) | **GET** /products/variants/{id} | Запрос на получение склейки товаров
*VariantsApi* | [**patchVariantGroup**](docs/Api/VariantsApi.md#patchvariantgroup) | **PATCH** /products/variants/{id} | Запрос на обновление отдельных свойств склейки
*VariantsApi* | [**replaceVariantGroup**](docs/Api/VariantsApi.md#replacevariantgroup) | **PUT** /products/variants/{id} | Запрос на обновление данных склейки
*VariantsApi* | [**searchVariantGroups**](docs/Api/VariantsApi.md#searchvariantgroups) | **POST** /products/variants:search | Поиск склеек, удовлетворяющих фильтру


## Documentation For Models

 - [AttributeDirectoryValue](docs/Model/AttributeDirectoryValue.md)
 - [BindCategoryPropertiesRequest](docs/Model/BindCategoryPropertiesRequest.md)
 - [BindCategoryPropertiesRequestProperties](docs/Model/BindCategoryPropertiesRequestProperties.md)
 - [Brand](docs/Model/Brand.md)
 - [BrandFillableProperties](docs/Model/BrandFillableProperties.md)
 - [BrandReadonlyProperties](docs/Model/BrandReadonlyProperties.md)
 - [BrandResponse](docs/Model/BrandResponse.md)
 - [CategoriesTreeFilter](docs/Model/CategoriesTreeFilter.md)
 - [CategoriesTreeItem](docs/Model/CategoriesTreeItem.md)
 - [CategoriesTreeRequest](docs/Model/CategoriesTreeRequest.md)
 - [CategoriesTreeResponse](docs/Model/CategoriesTreeResponse.md)
 - [Category](docs/Model/Category.md)
 - [CategoryBoundProperty](docs/Model/CategoryBoundProperty.md)
 - [CategoryFillableProperties](docs/Model/CategoryFillableProperties.md)
 - [CategoryIncludes](docs/Model/CategoryIncludes.md)
 - [CategoryReadonlyProperties](docs/Model/CategoryReadonlyProperties.md)
 - [CategoryResponse](docs/Model/CategoryResponse.md)
 - [CreateBrandRequest](docs/Model/CreateBrandRequest.md)
 - [CreateCategoryRequest](docs/Model/CreateCategoryRequest.md)
 - [CreateDirectoryValueRequest](docs/Model/CreateDirectoryValueRequest.md)
 - [CreateProductRequest](docs/Model/CreateProductRequest.md)
 - [CreatePropertyRequest](docs/Model/CreatePropertyRequest.md)
 - [CreateVariantGroupRequest](docs/Model/CreateVariantGroupRequest.md)
 - [DirectoryValue](docs/Model/DirectoryValue.md)
 - [DirectoryValueExtendedProperties](docs/Model/DirectoryValueExtendedProperties.md)
 - [DirectoryValueFillableProperties](docs/Model/DirectoryValueFillableProperties.md)
 - [DirectoryValueModifyProperties](docs/Model/DirectoryValueModifyProperties.md)
 - [DirectoryValueReadonlyProperties](docs/Model/DirectoryValueReadonlyProperties.md)
 - [DirectoryValueResponse](docs/Model/DirectoryValueResponse.md)
 - [EditProductAttributeValue](docs/Model/EditProductAttributeValue.md)
 - [EditProductImage](docs/Model/EditProductImage.md)
 - [EmptyDataResponse](docs/Model/EmptyDataResponse.md)
 - [EnumInfoProperties](docs/Model/EnumInfoProperties.md)
 - [Error](docs/Model/Error.md)
 - [ErrorResponse](docs/Model/ErrorResponse.md)
 - [ErrorResponse2](docs/Model/ErrorResponse2.md)
 - [FieldSettingsMaskEnum](docs/Model/FieldSettingsMaskEnum.md)
 - [File](docs/Model/File.md)
 - [IntegerEnumInfo](docs/Model/IntegerEnumInfo.md)
 - [IntegerEnumInfoProperties](docs/Model/IntegerEnumInfoProperties.md)
 - [IntegerEnumInfoResponse](docs/Model/IntegerEnumInfoResponse.md)
 - [MassOperationResult](docs/Model/MassOperationResult.md)
 - [MassOperationResultErrors](docs/Model/MassOperationResultErrors.md)
 - [MetricsCategoryEnum](docs/Model/MetricsCategoryEnum.md)
 - [MultipartFileUploadRequest](docs/Model/MultipartFileUploadRequest.md)
 - [PaginationTypeCursorEnum](docs/Model/PaginationTypeCursorEnum.md)
 - [PaginationTypeEnum](docs/Model/PaginationTypeEnum.md)
 - [PaginationTypeOffsetEnum](docs/Model/PaginationTypeOffsetEnum.md)
 - [PatchBrandRequest](docs/Model/PatchBrandRequest.md)
 - [PatchCategoryRequest](docs/Model/PatchCategoryRequest.md)
 - [PatchDirectoryValueRequest](docs/Model/PatchDirectoryValueRequest.md)
 - [PatchProductAttributesRequest](docs/Model/PatchProductAttributesRequest.md)
 - [PatchProductFieldRequest](docs/Model/PatchProductFieldRequest.md)
 - [PatchProductImagesRequest](docs/Model/PatchProductImagesRequest.md)
 - [PatchProductRequest](docs/Model/PatchProductRequest.md)
 - [PatchPropertyRequest](docs/Model/PatchPropertyRequest.md)
 - [PatchVariantGroupRequest](docs/Model/PatchVariantGroupRequest.md)
 - [PreloadFile](docs/Model/PreloadFile.md)
 - [PreloadFile2](docs/Model/PreloadFile2.md)
 - [PreloadFileData](docs/Model/PreloadFileData.md)
 - [Product](docs/Model/Product.md)
 - [ProductAttributeValue](docs/Model/ProductAttributeValue.md)
 - [ProductAttributeValueEditProperties](docs/Model/ProductAttributeValueEditProperties.md)
 - [ProductAttributeValueFillableProperties](docs/Model/ProductAttributeValueFillableProperties.md)
 - [ProductAttributeValueReadonlyProperties](docs/Model/ProductAttributeValueReadonlyProperties.md)
 - [ProductAttributesResponse](docs/Model/ProductAttributesResponse.md)
 - [ProductDraft](docs/Model/ProductDraft.md)
 - [ProductDraftResponse](docs/Model/ProductDraftResponse.md)
 - [ProductField](docs/Model/ProductField.md)
 - [ProductFieldFillableProperties](docs/Model/ProductFieldFillableProperties.md)
 - [ProductFieldReadonlyProperties](docs/Model/ProductFieldReadonlyProperties.md)
 - [ProductFieldResponse](docs/Model/ProductFieldResponse.md)
 - [ProductFillableProperties](docs/Model/ProductFillableProperties.md)
 - [ProductFlag](docs/Model/ProductFlag.md)
 - [ProductFlagEnum](docs/Model/ProductFlagEnum.md)
 - [ProductFlagFillableProperties](docs/Model/ProductFlagFillableProperties.md)
 - [ProductFlagReadonlyProperties](docs/Model/ProductFlagReadonlyProperties.md)
 - [ProductFlagResponse](docs/Model/ProductFlagResponse.md)
 - [ProductImage](docs/Model/ProductImage.md)
 - [ProductImageEditProperties](docs/Model/ProductImageEditProperties.md)
 - [ProductImageFillableProperties](docs/Model/ProductImageFillableProperties.md)
 - [ProductImageReadonlyProperties](docs/Model/ProductImageReadonlyProperties.md)
 - [ProductImagesResponse](docs/Model/ProductImagesResponse.md)
 - [ProductIncludes](docs/Model/ProductIncludes.md)
 - [ProductReadonlyProperties](docs/Model/ProductReadonlyProperties.md)
 - [ProductResponse](docs/Model/ProductResponse.md)
 - [ProductStatus](docs/Model/ProductStatus.md)
 - [ProductStatusEnum](docs/Model/ProductStatusEnum.md)
 - [ProductStatusFillableProperties](docs/Model/ProductStatusFillableProperties.md)
 - [ProductStatusProperties](docs/Model/ProductStatusProperties.md)
 - [ProductStatusReadonlyProperties](docs/Model/ProductStatusReadonlyProperties.md)
 - [ProductStatusResponse](docs/Model/ProductStatusResponse.md)
 - [ProductTypeEnum](docs/Model/ProductTypeEnum.md)
 - [Property](docs/Model/Property.md)
 - [PropertyFillableProperties](docs/Model/PropertyFillableProperties.md)
 - [PropertyIncludes](docs/Model/PropertyIncludes.md)
 - [PropertyReadonlyProperties](docs/Model/PropertyReadonlyProperties.md)
 - [PropertyResponse](docs/Model/PropertyResponse.md)
 - [PropertyTypeEnum](docs/Model/PropertyTypeEnum.md)
 - [PublishedProductProperties](docs/Model/PublishedProductProperties.md)
 - [ReplaceBrandRequest](docs/Model/ReplaceBrandRequest.md)
 - [ReplaceCategoryRequest](docs/Model/ReplaceCategoryRequest.md)
 - [ReplaceDirectoryValueRequest](docs/Model/ReplaceDirectoryValueRequest.md)
 - [ReplaceProductAttributesRequest](docs/Model/ReplaceProductAttributesRequest.md)
 - [ReplaceProductFlagRequest](docs/Model/ReplaceProductFlagRequest.md)
 - [ReplaceProductImagesRequest](docs/Model/ReplaceProductImagesRequest.md)
 - [ReplaceProductRequest](docs/Model/ReplaceProductRequest.md)
 - [ReplaceProductStatusRequest](docs/Model/ReplaceProductStatusRequest.md)
 - [ReplacePropertyRequest](docs/Model/ReplacePropertyRequest.md)
 - [ReplaceVariantGroupRequest](docs/Model/ReplaceVariantGroupRequest.md)
 - [RequestBodyCursorPagination](docs/Model/RequestBodyCursorPagination.md)
 - [RequestBodyMassDelete](docs/Model/RequestBodyMassDelete.md)
 - [RequestBodyOffsetPagination](docs/Model/RequestBodyOffsetPagination.md)
 - [RequestBodyPagination](docs/Model/RequestBodyPagination.md)
 - [ResponseBodyCursorPagination](docs/Model/ResponseBodyCursorPagination.md)
 - [ResponseBodyOffsetPagination](docs/Model/ResponseBodyOffsetPagination.md)
 - [ResponseBodyPagination](docs/Model/ResponseBodyPagination.md)
 - [SearchBrandsFilter](docs/Model/SearchBrandsFilter.md)
 - [SearchBrandsRequest](docs/Model/SearchBrandsRequest.md)
 - [SearchBrandsResponse](docs/Model/SearchBrandsResponse.md)
 - [SearchCategoriesFilter](docs/Model/SearchCategoriesFilter.md)
 - [SearchCategoriesRequest](docs/Model/SearchCategoriesRequest.md)
 - [SearchCategoriesResponse](docs/Model/SearchCategoriesResponse.md)
 - [SearchDirectoryValuesFilter](docs/Model/SearchDirectoryValuesFilter.md)
 - [SearchDirectoryValuesRequest](docs/Model/SearchDirectoryValuesRequest.md)
 - [SearchDirectoryValuesResponse](docs/Model/SearchDirectoryValuesResponse.md)
 - [SearchProductDraftsRequest](docs/Model/SearchProductDraftsRequest.md)
 - [SearchProductDraftsResponse](docs/Model/SearchProductDraftsResponse.md)
 - [SearchProductFieldsFilter](docs/Model/SearchProductFieldsFilter.md)
 - [SearchProductFieldsRequest](docs/Model/SearchProductFieldsRequest.md)
 - [SearchProductFieldsResponse](docs/Model/SearchProductFieldsResponse.md)
 - [SearchProductFieldsResponseMeta](docs/Model/SearchProductFieldsResponseMeta.md)
 - [SearchProductFlagsFilter](docs/Model/SearchProductFlagsFilter.md)
 - [SearchProductFlagsRequest](docs/Model/SearchProductFlagsRequest.md)
 - [SearchProductFlagsResponse](docs/Model/SearchProductFlagsResponse.md)
 - [SearchProductStatusesFilter](docs/Model/SearchProductStatusesFilter.md)
 - [SearchProductStatusesRequest](docs/Model/SearchProductStatusesRequest.md)
 - [SearchProductStatusesResponse](docs/Model/SearchProductStatusesResponse.md)
 - [SearchProductsRequest](docs/Model/SearchProductsRequest.md)
 - [SearchProductsResponse](docs/Model/SearchProductsResponse.md)
 - [SearchPropertiesRequest](docs/Model/SearchPropertiesRequest.md)
 - [SearchPropertiesResponse](docs/Model/SearchPropertiesResponse.md)
 - [SearchVariantGroupsFilter](docs/Model/SearchVariantGroupsFilter.md)
 - [SearchVariantGroupsRequest](docs/Model/SearchVariantGroupsRequest.md)
 - [SearchVariantGroupsResponse](docs/Model/SearchVariantGroupsResponse.md)
 - [StringEnumInfo](docs/Model/StringEnumInfo.md)
 - [StringEnumInfoProperties](docs/Model/StringEnumInfoProperties.md)
 - [StringEnumInfoResponse](docs/Model/StringEnumInfoResponse.md)
 - [VariantGroup](docs/Model/VariantGroup.md)
 - [VariantGroupFillableProperties](docs/Model/VariantGroupFillableProperties.md)
 - [VariantGroupIncludes](docs/Model/VariantGroupIncludes.md)
 - [VariantGroupReadOnlyProperties](docs/Model/VariantGroupReadOnlyProperties.md)
 - [VariantGroupResponse](docs/Model/VariantGroupResponse.md)


## Documentation For Authorization

All endpoints do not require authorization.

## Author



