<?php

namespace Ensi\PimClient;

class PimClientProvider
{
    /** @var string[] */
    public static $apis = [
        '\Ensi\PimClient\Api\ProductStatusesApi',
        '\Ensi\PimClient\Api\EnumsApi',
        '\Ensi\PimClient\Api\ProductFieldsApi',
        '\Ensi\PimClient\Api\CategoriesApi',
        '\Ensi\PimClient\Api\ProductsApi',
        '\Ensi\PimClient\Api\ProductFlagsApi',
        '\Ensi\PimClient\Api\PropertiesApi',
        '\Ensi\PimClient\Api\VariantsApi',
        '\Ensi\PimClient\Api\BrandsApi',
    ];

    /** @var string[] */
    public static $dtos = [
        '\Ensi\PimClient\Dto\PropertyIncludes',
        '\Ensi\PimClient\Dto\ProductFieldFillableProperties',
        '\Ensi\PimClient\Dto\PropertyTypeEnum',
        '\Ensi\PimClient\Dto\ProductImageFillableProperties',
        '\Ensi\PimClient\Dto\ReplaceVariantGroupRequest',
        '\Ensi\PimClient\Dto\SearchProductFieldsRequest',
        '\Ensi\PimClient\Dto\PreloadFile2',
        '\Ensi\PimClient\Dto\Brand',
        '\Ensi\PimClient\Dto\ProductAttributeValueReadonlyProperties',
        '\Ensi\PimClient\Dto\PatchVariantGroupRequest',
        '\Ensi\PimClient\Dto\CategoryIncludes',
        '\Ensi\PimClient\Dto\ProductField',
        '\Ensi\PimClient\Dto\ReplaceProductFlagRequest',
        '\Ensi\PimClient\Dto\EnumInfoProperties',
        '\Ensi\PimClient\Dto\ResponseBodyOffsetPagination',
        '\Ensi\PimClient\Dto\PatchBrandRequest',
        '\Ensi\PimClient\Dto\ProductDraft',
        '\Ensi\PimClient\Dto\ReplaceProductRequest',
        '\Ensi\PimClient\Dto\ReplaceBrandRequest',
        '\Ensi\PimClient\Dto\SearchBrandsRequest',
        '\Ensi\PimClient\Dto\CategoriesTreeResponse',
        '\Ensi\PimClient\Dto\SearchProductFlagsResponse',
        '\Ensi\PimClient\Dto\SearchDirectoryValuesRequest',
        '\Ensi\PimClient\Dto\ProductFlagFillableProperties',
        '\Ensi\PimClient\Dto\SearchProductDraftsResponse',
        '\Ensi\PimClient\Dto\SearchVariantGroupsResponse',
        '\Ensi\PimClient\Dto\PaginationTypeEnum',
        '\Ensi\PimClient\Dto\SearchBrandsResponse',
        '\Ensi\PimClient\Dto\Category',
        '\Ensi\PimClient\Dto\PatchProductFieldRequest',
        '\Ensi\PimClient\Dto\CategoriesTreeRequest',
        '\Ensi\PimClient\Dto\BindCategoryPropertiesRequest',
        '\Ensi\PimClient\Dto\CategoriesTreeItem',
        '\Ensi\PimClient\Dto\SearchVariantGroupsFilter',
        '\Ensi\PimClient\Dto\SearchCategoriesFilter',
        '\Ensi\PimClient\Dto\ProductFieldResponse',
        '\Ensi\PimClient\Dto\ErrorResponse2',
        '\Ensi\PimClient\Dto\BindCategoryPropertiesRequestProperties',
        '\Ensi\PimClient\Dto\Product',
        '\Ensi\PimClient\Dto\DirectoryValueFillableProperties',
        '\Ensi\PimClient\Dto\ProductStatusProperties',
        '\Ensi\PimClient\Dto\VariantGroupResponse',
        '\Ensi\PimClient\Dto\ProductImagesResponse',
        '\Ensi\PimClient\Dto\BrandResponse',
        '\Ensi\PimClient\Dto\RequestBodyOffsetPagination',
        '\Ensi\PimClient\Dto\VariantGroupReadOnlyProperties',
        '\Ensi\PimClient\Dto\SearchProductStatusesRequest',
        '\Ensi\PimClient\Dto\VariantGroupIncludes',
        '\Ensi\PimClient\Dto\PatchProductImagesRequest',
        '\Ensi\PimClient\Dto\BrandFillableProperties',
        '\Ensi\PimClient\Dto\ProductImageReadonlyProperties',
        '\Ensi\PimClient\Dto\ReplaceDirectoryValueRequest',
        '\Ensi\PimClient\Dto\ProductFillableProperties',
        '\Ensi\PimClient\Dto\ReplaceCategoryRequest',
        '\Ensi\PimClient\Dto\StringEnumInfoResponse',
        '\Ensi\PimClient\Dto\CreateDirectoryValueRequest',
        '\Ensi\PimClient\Dto\DirectoryValueExtendedProperties',
        '\Ensi\PimClient\Dto\ErrorResponse',
        '\Ensi\PimClient\Dto\ProductAttributeValueEditProperties',
        '\Ensi\PimClient\Dto\RequestBodyMassDelete',
        '\Ensi\PimClient\Dto\StringEnumInfo',
        '\Ensi\PimClient\Dto\ProductFlag',
        '\Ensi\PimClient\Dto\FieldSettingsMaskEnum',
        '\Ensi\PimClient\Dto\SearchProductFlagsFilter',
        '\Ensi\PimClient\Dto\ProductDraftResponse',
        '\Ensi\PimClient\Dto\ResponseBodyPagination',
        '\Ensi\PimClient\Dto\SearchProductFieldsResponseMeta',
        '\Ensi\PimClient\Dto\ProductFlagResponse',
        '\Ensi\PimClient\Dto\SearchVariantGroupsRequest',
        '\Ensi\PimClient\Dto\ProductStatusReadonlyProperties',
        '\Ensi\PimClient\Dto\PropertyResponse',
        '\Ensi\PimClient\Dto\EditProductImage',
        '\Ensi\PimClient\Dto\ModelInterface',
        '\Ensi\PimClient\Dto\CreateVariantGroupRequest',
        '\Ensi\PimClient\Dto\CategoryBoundProperty',
        '\Ensi\PimClient\Dto\PaginationTypeOffsetEnum',
        '\Ensi\PimClient\Dto\BrandReadonlyProperties',
        '\Ensi\PimClient\Dto\EmptyDataResponse',
        '\Ensi\PimClient\Dto\ProductIncludes',
        '\Ensi\PimClient\Dto\PropertyFillableProperties',
        '\Ensi\PimClient\Dto\CategoryReadonlyProperties',
        '\Ensi\PimClient\Dto\RequestBodyPagination',
        '\Ensi\PimClient\Dto\DirectoryValueReadonlyProperties',
        '\Ensi\PimClient\Dto\DirectoryValue',
        '\Ensi\PimClient\Dto\SearchProductDraftsRequest',
        '\Ensi\PimClient\Dto\SearchCategoriesResponse',
        '\Ensi\PimClient\Dto\SearchProductFieldsResponse',
        '\Ensi\PimClient\Dto\ReplaceProductAttributesRequest',
        '\Ensi\PimClient\Dto\ProductAttributeValueFillableProperties',
        '\Ensi\PimClient\Dto\PreloadFile',
        '\Ensi\PimClient\Dto\IntegerEnumInfoResponse',
        '\Ensi\PimClient\Dto\DirectoryValueModifyProperties',
        '\Ensi\PimClient\Dto\ProductFieldReadonlyProperties',
        '\Ensi\PimClient\Dto\SearchProductFieldsFilter',
        '\Ensi\PimClient\Dto\ProductImageEditProperties',
        '\Ensi\PimClient\Dto\SearchPropertiesResponse',
        '\Ensi\PimClient\Dto\ProductReadonlyProperties',
        '\Ensi\PimClient\Dto\PatchDirectoryValueRequest',
        '\Ensi\PimClient\Dto\ProductStatusResponse',
        '\Ensi\PimClient\Dto\PreloadFileData',
        '\Ensi\PimClient\Dto\PatchPropertyRequest',
        '\Ensi\PimClient\Dto\VariantGroupFillableProperties',
        '\Ensi\PimClient\Dto\PropertyReadonlyProperties',
        '\Ensi\PimClient\Dto\ProductResponse',
        '\Ensi\PimClient\Dto\SearchProductsResponse',
        '\Ensi\PimClient\Dto\MassOperationResultErrors',
        '\Ensi\PimClient\Dto\SearchProductsRequest',
        '\Ensi\PimClient\Dto\SearchProductStatusesFilter',
        '\Ensi\PimClient\Dto\Property',
        '\Ensi\PimClient\Dto\IntegerEnumInfoProperties',
        '\Ensi\PimClient\Dto\PatchProductRequest',
        '\Ensi\PimClient\Dto\ProductFlagEnum',
        '\Ensi\PimClient\Dto\ProductAttributesResponse',
        '\Ensi\PimClient\Dto\PatchCategoryRequest',
        '\Ensi\PimClient\Dto\CategoryResponse',
        '\Ensi\PimClient\Dto\ProductStatus',
        '\Ensi\PimClient\Dto\VariantGroup',
        '\Ensi\PimClient\Dto\CategoriesTreeFilter',
        '\Ensi\PimClient\Dto\DirectoryValueResponse',
        '\Ensi\PimClient\Dto\CategoryFillableProperties',
        '\Ensi\PimClient\Dto\PatchProductAttributesRequest',
        '\Ensi\PimClient\Dto\ReplaceProductStatusRequest',
        '\Ensi\PimClient\Dto\CreateBrandRequest',
        '\Ensi\PimClient\Dto\IntegerEnumInfo',
        '\Ensi\PimClient\Dto\ProductFlagReadonlyProperties',
        '\Ensi\PimClient\Dto\ReplacePropertyRequest',
        '\Ensi\PimClient\Dto\StringEnumInfoProperties',
        '\Ensi\PimClient\Dto\SearchCategoriesRequest',
        '\Ensi\PimClient\Dto\AttributeDirectoryValue',
        '\Ensi\PimClient\Dto\SearchProductFlagsRequest',
        '\Ensi\PimClient\Dto\MultipartFileUploadRequest',
        '\Ensi\PimClient\Dto\File',
        '\Ensi\PimClient\Dto\SearchBrandsFilter',
        '\Ensi\PimClient\Dto\ProductStatusFillableProperties',
        '\Ensi\PimClient\Dto\ProductTypeEnum',
        '\Ensi\PimClient\Dto\Error',
        '\Ensi\PimClient\Dto\PaginationTypeCursorEnum',
        '\Ensi\PimClient\Dto\MassOperationResult',
        '\Ensi\PimClient\Dto\ProductStatusEnum',
        '\Ensi\PimClient\Dto\RequestBodyCursorPagination',
        '\Ensi\PimClient\Dto\PublishedProductProperties',
        '\Ensi\PimClient\Dto\SearchDirectoryValuesFilter',
        '\Ensi\PimClient\Dto\ResponseBodyCursorPagination',
        '\Ensi\PimClient\Dto\CreateProductRequest',
        '\Ensi\PimClient\Dto\ProductAttributeValue',
        '\Ensi\PimClient\Dto\MetricsCategoryEnum',
        '\Ensi\PimClient\Dto\ProductImage',
        '\Ensi\PimClient\Dto\CreatePropertyRequest',
        '\Ensi\PimClient\Dto\SearchDirectoryValuesResponse',
        '\Ensi\PimClient\Dto\SearchProductStatusesResponse',
        '\Ensi\PimClient\Dto\CreateCategoryRequest',
        '\Ensi\PimClient\Dto\SearchPropertiesRequest',
        '\Ensi\PimClient\Dto\ReplaceProductImagesRequest',
        '\Ensi\PimClient\Dto\EditProductAttributeValue',
    ];

    /** @var string */
    public static $configuration = '\Ensi\PimClient\Configuration';
}
